<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_65) on Wed Jun 25 14:23:49 JST 2014 -->
<TITLE>
QuorumCnxManager
</TITLE>

<META NAME="date" CONTENT="2014-06-25">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="QuorumCnxManager";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumBean.html" title="class in org.apache.zookeeper.server.quorum"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Listener.html" title="class in org.apache.zookeeper.server.quorum"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?org/apache/zookeeper/server/quorum/QuorumCnxManager.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="QuorumCnxManager.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_class_summary">NESTED</A>&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
org.apache.zookeeper.server.quorum</FONT>
<BR>
Class QuorumCnxManager</H2>
<PRE>
java.lang.Object
  <IMG SRC="../../../../../resources/inherit.gif" ALT="extended by "><B>org.apache.zookeeper.server.quorum.QuorumCnxManager</B>
</PRE>
<HR>
<DL>
<DT><PRE>public class <B>QuorumCnxManager</B><DT>extends java.lang.Object</DL>
</PRE>

<P>
This class implements a connection manager for leader election using TCP. It
 maintains one connection for every pair of servers. The tricky part is to
 guarantee that there is exactly one connection for every pair of servers that
 are operating correctly and that can communicate over the network.
 
 If two servers try to start a connection concurrently, then the connection
 manager uses a very simple tie-breaking mechanism to decide which connection
 to drop based on the IP addressed of the two parties. 
 
 For every peer, the manager maintains a queue of messages to send. If the
 connection to any particular peer drops, then the sender thread puts the
 message back on the list. As this implementation currently uses a queue
 implementation to maintain messages to send to another peer, we add the
 message to the tail of the queue, thus changing the order of messages.
 Although this is not a problem for the leader election, it could be a problem
 when consolidating peer communication. This is to be verified, though.
<P>

<P>
<HR>

<P>
<!-- ======== NESTED CLASS SUMMARY ======== -->

<A NAME="nested_class_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Nested Class Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Listener.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager.Listener</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Thread to listen on some port</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static&nbsp;class</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Message.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager.Message</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Listener.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager.Listener</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#listener">listener</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.concurrent.ArrayBlockingQueue&lt;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Message.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager.Message</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#recvQueue">recvQueue</A></B></CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;
<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#QuorumCnxManager(org.apache.zookeeper.server.quorum.QuorumPeer)">QuorumCnxManager</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer</A>&nbsp;self)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#addToRecvQueue(org.apache.zookeeper.server.quorum.QuorumCnxManager.Message)">addToRecvQueue</A></B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Message.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager.Message</A>&nbsp;msg)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Inserts an element in the <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#recvQueue"><CODE>recvQueue</CODE></A>.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#connectAll()">connectAll</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Try to establish a connection with each server if one
 doesn't exist.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#getQuorumPeer()">getQuorumPeer</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return reference to QuorumPeer</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#getThreadCount()">getThreadCount</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Return number of worker threads</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#halt()">halt</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Flag that it is time to wrap up all activities and interrupt the listener.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#initiateConnection(java.net.Socket, java.lang.Long)">initiateConnection</A></B>(java.net.Socket&nbsp;sock,
                   java.lang.Long&nbsp;sid)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;If this server has initiated the connection, then it gives up on the
 connection if it loses challenge.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Message.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager.Message</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#pollRecvQueue(long, java.util.concurrent.TimeUnit)">pollRecvQueue</A></B>(long&nbsp;timeout,
              java.util.concurrent.TimeUnit&nbsp;unit)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Retrieves and removes a message at the head of this queue,
 waiting up to the specified wait time if necessary for an element to
 become available.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#receiveConnection(java.net.Socket)">receiveConnection</A></B>(java.net.Socket&nbsp;sock)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;If this server receives a connection request, then it gives up on the new
 connection if it wins.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#softHalt()">softHalt</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;A soft halt simply finishes workers.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#testInitiateConnection(long)">testInitiateConnection</A></B>(long&nbsp;sid)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Invokes initiateConnection for testing purposes</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#toSend(java.lang.Long, java.nio.ByteBuffer)">toSend</A></B>(java.lang.Long&nbsp;sid,
       java.nio.ByteBuffer&nbsp;b)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Processes invoke this message to queue a message to send.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ FIELD DETAIL =========== -->

<A NAME="field_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Field Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="recvQueue"><!-- --></A><H3>
recvQueue</H3>
<PRE>
public final java.util.concurrent.ArrayBlockingQueue&lt;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Message.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager.Message</A>&gt; <B>recvQueue</B></PRE>
<DL>
<DL>
</DL>
</DL>
<HR>

<A NAME="listener"><!-- --></A><H3>
listener</H3>
<PRE>
public final <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Listener.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager.Listener</A> <B>listener</B></PRE>
<DL>
<DL>
</DL>
</DL>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="QuorumCnxManager(org.apache.zookeeper.server.quorum.QuorumPeer)"><!-- --></A><H3>
QuorumCnxManager</H3>
<PRE>
public <B>QuorumCnxManager</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer</A>&nbsp;self)</PRE>
<DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="testInitiateConnection(long)"><!-- --></A><H3>
testInitiateConnection</H3>
<PRE>
public void <B>testInitiateConnection</B>(long&nbsp;sid)
                            throws java.lang.Exception</PRE>
<DL>
<DD>Invokes initiateConnection for testing purposes
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>sid</CODE> - 
<DT><B>Throws:</B>
<DD><CODE>java.lang.Exception</CODE></DL>
</DD>
</DL>
<HR>

<A NAME="initiateConnection(java.net.Socket, java.lang.Long)"><!-- --></A><H3>
initiateConnection</H3>
<PRE>
public boolean <B>initiateConnection</B>(java.net.Socket&nbsp;sock,
                                  java.lang.Long&nbsp;sid)</PRE>
<DL>
<DD>If this server has initiated the connection, then it gives up on the
 connection if it loses challenge. Otherwise, it keeps the connection.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="receiveConnection(java.net.Socket)"><!-- --></A><H3>
receiveConnection</H3>
<PRE>
public boolean <B>receiveConnection</B>(java.net.Socket&nbsp;sock)</PRE>
<DL>
<DD>If this server receives a connection request, then it gives up on the new
 connection if it wins. Notice that it checks whether it has a connection
 to this server already or not. If it does, then it sends the smallest
 possible long value to lose the challenge.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="toSend(java.lang.Long, java.nio.ByteBuffer)"><!-- --></A><H3>
toSend</H3>
<PRE>
public void <B>toSend</B>(java.lang.Long&nbsp;sid,
                   java.nio.ByteBuffer&nbsp;b)</PRE>
<DL>
<DD>Processes invoke this message to queue a message to send. Currently, 
 only leader election uses it.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="connectAll()"><!-- --></A><H3>
connectAll</H3>
<PRE>
public void <B>connectAll</B>()</PRE>
<DL>
<DD>Try to establish a connection with each server if one
 doesn't exist.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="halt()"><!-- --></A><H3>
halt</H3>
<PRE>
public void <B>halt</B>()</PRE>
<DL>
<DD>Flag that it is time to wrap up all activities and interrupt the listener.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="softHalt()"><!-- --></A><H3>
softHalt</H3>
<PRE>
public void <B>softHalt</B>()</PRE>
<DL>
<DD>A soft halt simply finishes workers.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getThreadCount()"><!-- --></A><H3>
getThreadCount</H3>
<PRE>
public long <B>getThreadCount</B>()</PRE>
<DL>
<DD>Return number of worker threads
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getQuorumPeer()"><!-- --></A><H3>
getQuorumPeer</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumPeer.html" title="class in org.apache.zookeeper.server.quorum">QuorumPeer</A> <B>getQuorumPeer</B>()</PRE>
<DL>
<DD>Return reference to QuorumPeer
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="addToRecvQueue(org.apache.zookeeper.server.quorum.QuorumCnxManager.Message)"><!-- --></A><H3>
addToRecvQueue</H3>
<PRE>
public void <B>addToRecvQueue</B>(<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Message.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager.Message</A>&nbsp;msg)</PRE>
<DL>
<DD>Inserts an element in the <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.html#recvQueue"><CODE>recvQueue</CODE></A>. If the Queue is full, this
 methods removes an element from the head of the Queue and then inserts
 the element at the tail of the queue.

 This method is synchronized to achieve fairness between two threads that
 are trying to insert an element in the queue. Each thread checks if the
 queue is full, then removes the element at the head of the queue, and
 then inserts an element at the tail. This three-step process is done to
 prevent a thread from blocking while inserting an element in the queue.
 If we do not synchronize the call to this method, then a thread can grab
 a slot in the queue created by the second thread. This can cause the call
 to insert by the second thread to fail.
 Note that synchronizing this method does not block another thread
 from polling the queue since that synchronization is provided by the
 queue itself.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>msg</CODE> - Reference to the message to be inserted in the queue</DL>
</DD>
</DL>
<HR>

<A NAME="pollRecvQueue(long, java.util.concurrent.TimeUnit)"><!-- --></A><H3>
pollRecvQueue</H3>
<PRE>
public <A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Message.html" title="class in org.apache.zookeeper.server.quorum">QuorumCnxManager.Message</A> <B>pollRecvQueue</B>(long&nbsp;timeout,
                                              java.util.concurrent.TimeUnit&nbsp;unit)
                                       throws java.lang.InterruptedException</PRE>
<DL>
<DD>Retrieves and removes a message at the head of this queue,
 waiting up to the specified wait time if necessary for an element to
 become available.

 <CODE>ArrayBlockingQueue.poll(long, java.util.concurrent.TimeUnit)</CODE>
<P>
<DD><DL>

<DT><B>Throws:</B>
<DD><CODE>java.lang.InterruptedException</CODE></DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumBean.html" title="class in org.apache.zookeeper.server.quorum"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../../org/apache/zookeeper/server/quorum/QuorumCnxManager.Listener.html" title="class in org.apache.zookeeper.server.quorum"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../../index.html?org/apache/zookeeper/server/quorum/QuorumCnxManager.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="QuorumCnxManager.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_class_summary">NESTED</A>&nbsp;|&nbsp;<A HREF="#field_summary">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;<A HREF="#field_detail">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
